/* GCC */

#define MaxLength 10000
#define maxn 500

#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

char s[MaxLength];
vector <vector <int> > v[2];
queue <pair <int, int> > q;
int state[maxn][2];

inline bool bfs(int b, int step)
{
    int x = q.front().first;
    int turn = q.front().second;
    int turn2 = (turn + 1) % 2;
    for (int i = 0; i < v[turn][x].size(); i++)
        if (state[v[turn][x][i]][turn] == 0)
        {
            state[v[turn][x][i]][turn] = step + 1;
            q.push(make_pair(v[turn][x][i], turn2));
            if (v[turn][x][i] == b)
                return true;
        }
    return false;
}

int main()
{
    freopen("assoc.in", "r", stdin);
    freopen("assoc.out", "w", stdout);
    int n, a, b;
    scanf("%d %d %d\n", &n, &a, &b);
    a--;
    b--;
    for (int i = 0; i < n; i++)
    {
        int x, offset, readchcount;
        vector <int> temp;
        fgets(s, MaxLength, stdin);
        sscanf(s, "%d%n", &x, &offset);
        temp.push_back(x - 1);
        while (sscanf(s + offset, "%d%n", &x, &readchcount) > 0)
        {
            temp.push_back(x - 1);
            offset += readchcount;
        }
        v[0].push_back(temp);
    }
    for (int i = 0; i < n; i++)
    {
        int x, offset, readchcount;
        vector <int> temp;
        fgets(s, MaxLength, stdin);
        sscanf(s, "%d%n", &x, &offset);
        temp.push_back(x - 1);
        while (sscanf(s + offset, "%d%n", &x, &readchcount) > 0)
        {
            temp.push_back(x - 1);
            offset += readchcount;
        }
        v[1].push_back(temp);
    }
    for (int i = 0; i < n; i++)
    {
        state[i][0] = 0;
        state[i][1] = 0;
    }
    state[a][0] = 1;
    q.push(make_pair(a, 1));
    int step = 1;
    if (a == b)
    {
        printf("1\n");
        return 0;
    }
    while (!q.empty() && !bfs(b, step))
    {
        step = state[q.front().first][(q.front().second + 1) % 2] + 1;
        q.pop();
    }
    if (state[b][0] == 0 && state[b][1] == 0)
        printf("0\n");
    else
        printf("%d\n", step + 1);
    return 0;
}
