/* GCC */

#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

long a, b;
unsigned long long n;
int c[7];
vector<int> tc[7];

int cycles[7][7]; //[v][len]

bool explored[7];
int cnt = 0, pts = 0;
void dfs0(int v) {
    explored[v] = true;
    pts += v;
    cnt++;

    if(c[v] == 0) {
        cycles[0][cnt] = max(cycles[0][cnt], pts);
    } else if(!explored[c[v]]) {
        dfs0(c[v]);
    }

    cnt--;
    pts -= v;
    explored[v] = false;
}

int to_find;
void dfs1(int v) {
    if(v == 0)
        return;

    explored[v] = true;
    pts += v;
    cnt++;

    if(v == to_find) {
        cycles[to_find][cnt] = max(cycles[to_find][cnt], pts);
    } else if(!explored[c[v]]) {
        dfs1(c[v]);
    }

    cnt--;
    pts -= v;
    explored[v] = false;
}

int left;
int dfs2(int v) {
    left--;
    int res = v;
    if(left) {
        res += dfs2(c[v]);
    }
    return res;
}

int dfs2t(int v) {
    left--;
    int bst = 0;
    if(left) {
        for(int i = 0; i <= tc[v].size(); i++) {
            bst = max(bst, dfs2t(tc[v][i]));
        }
    }
    left++;

    return v + bst;
}

unsigned long long res, lres, cycles_n;
int res_small;

int main() {
    freopen("die.in", "r", stdin);
    freopen("die.out", "w", stdout);

    scanf("%ld%ld", &a, &b);

    n = (1LL << a) + b;

    for(int i = 1; i <= 6; i++) {
        scanf("%d", c + i);
        tc[c[i]].push_back(i);
    }

    for(int i = 1; i <= 6; i++) {
        dfs0(i);
    }

    for(int i = 1; i <= 6; i++) {
        to_find = i;
        dfs1(c[i]);
    }

    for(int v = 0; v <= 6; v++) {
        for(int len = 1; len <= 6; len++) {
            if(cycles[v][len]) {
                cycles_n = (n / len);
                left = n - cycles_n*len;
                lres = cycles[v][len] * cycles_n;
                if(left) {
                    if(v == 0) {
                        int bst = 0;
                        for(int i = 1; i <= 6; i++) {
                            bst = max(bst, dfs2(i));
                            left = n - cycles_n*len;
                        }
                        for(int i = 1; i <= 6; i++) {
                            bst = max(bst, dfs2t(i));
                            left = n - cycles_n*len;
                        }
                        lres += bst;
                    } else {
                        int bst =  dfs2(v);
                        for(int i = 1; i <= 6; i++) {
                            bst = max(bst, dfs2t(i));
                            left = n - cycles_n*len;
                        }
                        lres += bst;
                    }
                }
                res = max(res, lres);
            }
        }
    }

    res_small = res % 2011;

    printf("%d\n", res_small);

    return 0;
}
