/* GCC */

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <climits>
#include <queue>
using namespace std;

int main()
{
    FILE* fin = fopen("assoc.in", "r");
    FILE* fout = fopen("assoc.out", "w");
    int n, a, b;
    fscanf(fin, "%d%d%d\n", &n, &a, &b);
    int size = n<<1;
    int** mtx = new int*[size];
    for (int i=0; i<size; ++i)
    {
        mtx[i]=new int[size];
        memset(mtx[i], 0, sizeof(int)*size);
    }

    for (int i=0; i<n; ++i)
    {
        while (true)
        {
            int t;
            char ch;
            fscanf(fin, "%d%c", &t, &ch);
            mtx[i][t+n-1] = 1;
            if (ch=='\n')
            {
                break;
            }
        }
    }
    for (int i=0; i<n; ++i)
    {
        while (true)
        {
            int t;
            char ch;
            fscanf(fin, "%d%c", &t, &ch);
            mtx[i+n][t-1] = 1;
            if (ch=='\n')
            {
                break;
            }
        }
    }
    fclose(fin);
//    for (int i=0;i<size;++i)
//    {
//        for (int j=0;j<size;++j)
//            if (mtx[i][j]) cout << i << ' '<<j<<';';
//        cout << endl;
//
//    }
    int start = a+n-1, finish=b-1;
    int* dist = new int[size];
    bool* visited = new bool[size];
    queue<int> q;
    for (int i=0;i<size;++i)
    {
        dist[i] = INT_MAX;
        visited[i] = false;

    }
    dist[start] = 1;
    int index = start;
    q.push(start);
    while (!q.empty())
    {
        index = q.front();
        if (index%n == finish)
        {
            fprintf(fout, "%d\n", dist[index]);
            fclose(fout);
            return 0;
        }
        q.pop();
        for (int i=0; i<size; ++i)
            if (mtx[index][i] && dist[i]> dist[index]+1)
            {
                dist[i] = dist[index] + 1;
                if (!visited[i]) q.push(i);
            }
        visited[index] = true;
    }
    fprintf(fout, "0\n");
    fclose(fout);
//    for (int i=0;i<size;++i)
//        cout << dist[i] << ' ';
//    cout << endl << dist[finish];
    return 0;
}
