/* GCC */
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#define OUTPUT4FILES(taskname) \
    freopen(#taskname".in",  "r", stdin); \
    freopen(#taskname".out", "w", stdout); \
    /**/

using namespace std;

class Word
{
public:
    Word() {}
    ~Word() {}

    void assocWith(Word &word)
    {
        for (int j = 0; j < m_assoc.size(); j++)
            if (*m_assoc[j] == word)
                return;

        m_assoc.push_back(&word);
    }

    const vector<Word*> &assoc()
    {
        return m_assoc;
    }

    bool operator== (const Word &right)
    {
        return right.id == id;
    }

    int id;

    vector<Word*> m_assoc;
};

int n, A, B;
vector<Word> Aw;
vector<Word> Bw;

const vector<Word> &choose(bool side)
{
    return side ? Aw : Bw;
}

struct LookForNode
{
    int id;
    int depth;
    bool side;
};

void lookFor(int point)
{
    vector<LookForNode> looker;
    LookForNode starting;
    starting.id = point;
    starting.depth = 1;
    starting.side = false;
    looker.push_back(starting);

    for (int k = 0; k < looker.size(); k++) {
        LookForNode parent = looker[k];
        Word parentWord = choose(parent.side)[parent.id];
        if (parentWord.id == B) {
            cout << parent.depth << endl;
            return;
        }

        vector<Word*> children = parentWord.assoc();
        for (int j = 0; j < children.size(); j++) {
            LookForNode child;
            child.id = children[j]->id;
            child.depth = parent.depth+1;
            child.side = !parent.side;
            looker.push_back(child);
        }
    }

    cout << 0 << endl;
}

int main()
{
    OUTPUT4FILES(assoc);

    scanf("%d %d %d\n", &n, &A, &B);
    Aw.resize(n+1);
    Bw.resize(n+1);

    for (int j = 1; j <= n; j++) {
        int d = 0;
        char c = 0;
        while (c != '\n') {
            scanf("%d%c", &d, &c);
            Aw[j].id = j;
            Aw[d].id = d;
            Aw[j].assocWith(Aw[d]);
        }
    }

    for (int j = 1; j <= n; j++) {
        int d = 0;
        char c = 0;
        while (c != '\n') {
            scanf("%d%c", &d, &c);
            Bw[j].id = j;
            Bw[d].id = d;
            Bw[j].assocWith(Bw[d]);
        }
    }

    lookFor(A);

    return 0;
}
